#include "bioscall.h"

/* bios_divmod() ***********************
   Convert n/d to a mixed fraction q+r/d
   Returns Q.
*/
CODE_IN_IWRAM
int bios_divmod (int num, int den, int *rem)
{
  int quo;

  asm volatile (
    " mov   r0,%2  \n"
    " mov   r1,%3  \n"
    " swi   0x60000\n"  /* in ARM, s/6/0x60000/ */
    " mov   %0,r0  \n"
    " ldr   r2,%1  \n"
    " str   r1,[r2]\n"
    : "=r" (quo), "=m" (rem) // Outputs
    : "r" (num), "r" (den)   // Inputs
    : "r0","r1","r2","r3"    // clobber
  );
  return quo;
}
