#ifndef _KEY_H_
#define _KEY_H_
#include <gba.h>
#ifdef __cplusplus
extern "C" {
#endif

#define KEY_ABUTTON	(0x0001)
#define KEY_BBUTTON	(0x0002)
#define KEY_SELECT	(0x0004)
#define KEY_START	(0x0008)
#define KEY_RIGHT	(0x0010)
#define KEY_LEFT	(0x0020)
#define KEY_UP		(0x0040)
#define KEY_DOWN	(0x0080)
#define KEY_RBUTTON	(0x0100)
#define KEY_LBUTTON	(0x0200)

#define BUTTON_A		0
#define BUTTON_B		1
#define BUTTON_SEL		2
#define BUTTON_STA		3
#define CURSOR_R		4
#define CURSOR_L		5
#define CURSOR_U		6
#define CURSOR_D		7
#define BUTTON_R		8
#define BUTTON_L		9

#define KEY_UR		(KEY_UP   | KEY_RIGHT)
#define KEY_DR		(KEY_DOWN | KEY_RIGHT)
#define KEY_DL		(KEY_DOWN | KEY_LEFT)
#define KEY_UL		(KEY_UP   | KEY_LEFT)

#define KEY_INTERRUPT_AND	(0x8000)
#define KEY_INTERRUPT_OR	(0x0000)
#define KEY_INTERRUPT		(0x4000)

#define KEY_BUTTON_MASK	(KEY_ABUTTON | KEY_BBUTTON | KEY_SELECT | KEY_START | KEY_LBUTTON | KEY_RBUTTON)
#define KEY_CURSOR_MASK	(KEY_RIGHT | KEY_LEFT | KEY_UP | KEY_DOWN)
#define KEY_CURSOR(key)	(((key) & KEY_CURSOR_MASK) >> 4)

typedef struct {
	u16 cnt; // ݂̃L[
	u16 trg; // ꂽL[
	u16 off; // ꂽL[
	u16 old; // ÕL[
} KEY_STATUS;

extern KEY_STATUS key;
void KeyCheck();
void KeyArray_Init(void);
void KeyArray_Change(u16 b1, u16 b2);

#ifdef __cplusplus
}
#endif
#endif /* _KEY_H_ */
