//==============================================================================
// dmachain.c DMA3Ǘ
//==============================================================================
#include <gba.h>
#include <dmachain.h>

static u16 dma_chain_num = 0;
static u16 dma_chain_exec = 0;

//----------------------------------
// Globals
//----------------------------------
DMA_CHAIN dma_chain[MAX_DMA_CHAINS] IN_EWRAM;	// DMA]`FC

//----------------------------------------------------------
// Oobt@ɒǉ
//----------------------------------------------------------
CODE_IN_IWRAM 
void DMAChain_Enqueue(u32* src, u32* dst, u16 size)
{
	dma_chain[dma_chain_num].src = src;
	dma_chain[dma_chain_num].dst = dst;
	dma_chain[dma_chain_num].size = size;
	dma_chain_num++;
	dma_chain_num &= (MAX_DMA_CHAINS - 1);
}

//----------------------------------------------------------
// ]
//----------------------------------------------------------
CODE_IN_IWRAM 
void DMAChain_Transfer()
{
	while (dma_chain[dma_chain_exec].size > 0) {
//		while (REG_DMA3CNT & DMA_ENABLE) {}
		DMA3COPY(dma_chain[dma_chain_exec].src,
		         dma_chain[dma_chain_exec].dst,
		         dma_chain[dma_chain_exec].size,
		         (DMA_DEST_INC | DMA_SRC_INC | DMA_16BIT | DMA_IMMEDIATE | DMA_ENABLE) );
		dma_chain[dma_chain_exec].size = 0;
		dma_chain_exec++;
		dma_chain_exec &= (MAX_DMA_CHAINS - 1);
	}
}

