#ifndef PCG_CACHE_H
#define PCG_CACHE_H
#include <gba.h>
#include <sprite.h>
#ifdef __cplusplus
extern "C" {
#endif

//----------------------------------
// Defines
//----------------------------------
#define PATTERN_NOT_USED	0xffff
#define USE_DMA_CHAIN

//----------------------------------
// Structs
//----------------------------------
// LbVubN
typedef struct {
	u8 size;		// gp/ ^C
	u8 ref;			// QƉ
	u16 pat;		// ۂɊi[Ăp^[
} ATTR_PACKED PCG_BLOCK;

//----------------------------------
// Globals
//----------------------------------
extern TILE_BLOCK *tile_block;
extern u16 pcg_ref[] IN_EWRAM;
extern PCG_BLOCK pcg_block[MAX_TILES] IN_EWRAM;

//----------------------------------
// Functions
//----------------------------------
void PCG_Init();
CODE_IN_IWRAM void PCG_SearchBlankCache(u16 pattern);
CODE_IN_IWRAM u16 PCG_Set(u16 num);
CODE_IN_IWRAM void PCG_Release(u16 num);
CODE_IN_IWRAM void PCG_ReleaseTile(u16 num);
CODE_IN_IWRAM void PCG_CleanCache(void);

#ifdef __cplusplus
}
#endif

#endif
