//==============================================================================
// pcgcache.c PCGLbVǗ
//==============================================================================
/*
    ܂ȗ

      p^[ԍn
      tQƃe[u^CԍT
       |
       +---PATTERN_NOT_USEDłȂ
       |   |
       |   +---^CǗe[u̎QƐCN
       |       ret
       |
       +---PATTERN_NOT_USED
           |
           +---Ǘe[u[ȋ󂫗eʂT
               |
               +---
               |
               |       DMAœ]
               |       ret
               |
               ----Ȃ
                   |
                   +---fꂽ󂫗̈|čēxT
                       |
                       +---
                       |
                       |       DMAœ]
                       |       ret
                       |
                       +---ς茩Ȃ

                               ǂ悤I
                               ret
*/
#include <gba.h>
#include <pcgcache.h>
#include <sprite.h>

#ifdef USE_DMA_CHAIN
#	include <dmachain.h>
#endif

#include "./res/_ChrTable.h"

//----------------------------------
// ϐEz錾
//----------------------------------
// ^C
TILE_BLOCK *tile_block = (TILE_BLOCK *)OAMdata;

// p^[ԍ^Cio[tQƂe[u
u16 pattern_ref[ sizeof(ChrTable) / sizeof(ChrTable[0]) ] IN_EWRAM;

// ^CubN̎gp󋵂Ǘe[u
PCG_BLOCK pcg_block[MAX_TILES] IN_EWRAM;

// ŌɃ`FbN^C
static u16 lastchecked_tile;

//----------------------------------------------------------
// e[u
//----------------------------------------------------------
void
PCG_Init(void)
{
	u32 i;

	for (i = 0; i < MAX_TILES; i++) {
		pcg_block[i].size = 0;
		pcg_block[i].ref = 0;
		pcg_block[i].pat = PATTERN_NOT_USED;
	}

	for (i = 0; i < MAX_TILES; i += 64) {
		pcg_block[i].size = 64;
	}

	// ŏ1ubN͐ΎgȂ
	pcg_block[0].size = 1;
	pcg_block[0].ref  = 0xff;
	pcg_block[1].size = 63;

	for (i = 0; i < (sizeof(pattern_ref) / sizeof(pattern_ref[0])); i++ ) {
		pattern_ref[i] = PATTERN_NOT_USED;
	}

	lastchecked_tile = 1;
	return;
}

//----------------------------------------------------------
// 󂫃ubNT
//----------------------------------------------------------
CODE_IN_IWRAM 
void 
PCG_SearchBlankCache(u16 pattern)
{
	// ݂ next-fit ̗pĂ܂A
	//  lastchecked_tile = 1;
	// Ƃ邩
	//  u16 num = 1;
	// ƏƂ first-fit ɂȂ܂B
	// ̍ہAPCG_Release() ̃RgOƂŃRpNV̌ʂ܂B
	// iLbV͍sȂȂ܂j

	u16 num;
	u8 size = SprBlockSize[ChrTable[pattern].shape];

	if (size + lastchecked_tile >= MAX_TILES) {
		lastchecked_tile = 1;
	}
	num = lastchecked_tile;

	while (num < MAX_TILES) {
		// QƐ0Ȃ󂫃ubN
		if (pcg_block[num].ref == 0) {

			// ~TCY
			if (pcg_block[num].size >= size) {

				// ~TCY󂫗̈悪傫΁AubN𕪊
				if (pcg_block[num].size > size) {
					pcg_block[num+size].size = pcg_block[num].size - size;
					pcg_block[num].size = size;
				}

				// ㏑邽߁AÂp^[cĂ玀SʒmiėpoȂj
				if (pcg_block[num].pat != PATTERN_NOT_USED) {
					pattern_ref[pcg_block[num].pat] = PATTERN_NOT_USED;
				}

#ifdef	USE_DMA_CHAIN
				// V-DISPVRAMւDMA]oȂ̂ŁA
				// L[ɓ]v𗭂߂Ă
				DMAChain_Enqueue((u32*)ChrTable[pattern].addr, 
				                 (u32*)&(tile_block[num].tile[0]),
				                 size * 16);
#else
				DMA3COPY((u32 *)ChrTable[pattern].addr,
				         (u32 *)&(tile_block[num].tile[0]),
				         size * 16,
				         (DMA_DEST_INC | DMA_SRC_INC | DMA_16BIT | DMA_IMMEDIATE | DMA_ENABLE) );
#endif /* USE_DMA_CHAIN */

				// QƐCN
				pcg_block[num].pat = pattern;
				if (pcg_block[num].ref < 255)
					pcg_block[num].ref++;

				pattern_ref[pattern] = num;

				lastchecked_tile =  num + pcg_block[num].size;
//				if (lastchecked_tile > 960) {
//					lastchecked_tile =  1;
//				}
				return;
			}

			// QƐ0̂́AKvƂTCY𖞂ĂȂ
			// [vɖ߂

		}
		num += pcg_block[num].size;
	}

	// 󂫃ubNȂ
	pattern_ref[pattern] = PATTERN_NOT_USED;
	lastchecked_tile =  1;
}

//----------------------------------------------------------
// PCGo^
//----------------------------------------------------------
CODE_IN_IWRAM 
u16 
PCG_Set(u16 num)
{
	u16 *ref = &pattern_ref[num];

	// vꂽp^[LbVɍڂĂ邩
	// tQƃe[uɎcĂ^Cʂ̃p^[ɏ㏑ĂȂ
	// `FbN
	if ((*ref >= MAX_TILES) || (num != pcg_block[*ref].pat)) {

		// 󂫃^CTĂ (next-fit)
		PCG_SearchBlankCache(num);

		// Ȃ̂łx (first-fit)
		if (*ref == PATTERN_NOT_USED) {
			PCG_SearchBlankCache(num);
			if (*ref == PATTERN_NOT_USED) {
				// łȂ΁A|ĂT
				PCG_CleanCache();
				PCG_SearchBlankCache(num);
			}
		}

		// ǂɊւ炸^CԍԂ
		return *ref;

	} else {

//		u8 size = SprBlockSize[ChrTable[num].shape];
		u16 bnum = pattern_ref[num];

		// QƐCN
		if (pcg_block[*ref].ref < 255)
			pcg_block[*ref].ref++;

/*
		// XgO΂ōėpłLbVꍇ
		// ubNĂ邩ǂmF
		// iłł́AȂ悤ɂĂ̂ŃRgAEgĂ܂j
		if (pcg_block[*ref].size > size) {
			pcg_block[*ref+size].size = pcg_block[*ref].size - size;
			pcg_block[*ref].size = size;
		}
*/

		return bnum;

	}
}

//----------------------------------------------------------
// PCGJ(p^[ԍw)
//----------------------------------------------------------
CODE_IN_IWRAM 
void 
PCG_Release(u16 num)
{
	u16 tilenum = pattern_ref[num];

	// gp̃p^[J悤ƂĂI
	if (pattern_ref[num] == PATTERN_NOT_USED)
		return;

	// QƉ񐔂fN
	if (pcg_block[tilenum].ref > 0) {
		pcg_block[tilenum].ref--;
	}

	// łł́Aȉ̋ubN[`̓RgAEgĂ܂B
	// RgOƗ̈̕f኱ɘa܂B
	// p^[]ʂ͑邩܂B
	// PCG_Set() ̃RgOĂB
/*
	// QƉ񐔂 0 ɂȂ
	if (pcg_block[tilenum].ref == 0) {
		u16 next = pcg_block[tilenum].size + tilenum;

		// ̃ubNoԂۂmF
		if (pcg_block[next].ref == 0) {
			u16 join_size = pcg_block[tilenum].size + pcg_block[next].size;
			// ł悤ȂA
			if ( join_size < 256 )
			{
				pcg_block[tilenum].size += pcg_block[next].size;
				pcg_block[next].size = 0;
				// ɌÂp^[cĂASʒmiėpoȂj
				if (pcg_block[next].pat != PATTERN_NOT_USED) {
					pattern_ref[pcg_block[next].pat] = PATTERN_NOT_USED;
					pcg_block[next].pat = PATTERN_NOT_USED;
				}
			}
		}
	}
*/

}

//----------------------------------------------------------
// PCGJ(^Cio[w)
//----------------------------------------------------------
CODE_IN_IWRAM 
void 
PCG_ReleaseTile(u16 num)
{
	// ^Cԍp^[ԍ𓾂
	u16 pat = pcg_block[num].pat;

	if (pat >= MAX_TILES) {
		// Ƃp^[͖gp
		return;
	} else {
		PCG_Release(pat);
	}
}

//----------------------------------------------------------
// Ǘe[u𓪂琸āAubNA
//----------------------------------------------------------
/*
 xڂ̋ubNvŕKvȃubNȂꍇÅ֐
 Ă΂܂BA܂ŋ󂢂ĂubNA邾Ȃ̂ŁA
 f[ɂȂꍇ͑傫ȃTCỸubNȂꍇ܂B
*/ 
CODE_IN_IWRAM 
void 
PCG_CleanCache(void)
{
	u16 num = 1;
	while (num < MAX_TILES) {

		// QƉ񐔂0Ȃ󂫃ubN
		if (pcg_block[num].ref == 0) {
			u16 next = num + pcg_block[num].size;

			// ݂̃p^[ɎSʒm
			pattern_ref[pcg_block[num].pat] = PATTERN_NOT_USED;

			// ̃ubNoԂۂmF
			while (pcg_block[next].ref == 0) {
				u16 join_size = pcg_block[num].size + pcg_block[next].size;

				// ł悤ȂA
				if ( join_size < 256 ) {
					pcg_block[num].size += pcg_block[next].size;
					pcg_block[next].size = 0;
					// ꂽ߁AɌÂp^[ΎSʒmiėpoȂj
					if (pcg_block[next].pat != PATTERN_NOT_USED) {
						pattern_ref[pcg_block[next].pat] = PATTERN_NOT_USED;
						pcg_block[next].pat = PATTERN_NOT_USED;
					}
				} else {
					// łȂ̂Ń[v𔲂
					break;
				}

				next = num + pcg_block[num].size;
			}
		}
		num += pcg_block[num].size;
	}
}
