//==============================================================================
// sprite.c XvCgǗVXe
//==============================================================================
#include <gba.h>
#include <sprite.h>
// #include <doubler.h>
#include <pcgcache.h>
#include <dmachain.h>

u16 SprUsed;				// gp̉zXvCg
static SPRWORK SprHead;		// 擪p̉zXvCg
static SPRWORK SprTail;		// p̉zXvCg
static SPRWORK *LastSpr;	// ŌɌmzXvCg
static SPRWORK *SprStack[MAX_WORKSPR];	// gpXvCgAhX̃X^bN
SPRWORK tempSprWork;	// e|
static s32 world_x = 256;
static s32 world_y = 256;
static s32 view_x = 256;
static s32 view_y = 0;

#ifndef USE_SPR_MACRO
static SPR_PAT *SprPattern;
#else
SPR_PAT *SprPattern;
#endif

//---------------------------------------------------------
// Defines
#define SPRPRI_SYS_HEAD	0xff
#define SPRPRI_SYS_TAIL	0x00

//---------------------------------------------------------
// Prototypes
CODE_IN_IWRAM static void SpriteRealInit(u16 top, u16 num);
CODE_IN_IWRAM static void SpriteWorkInit(SPRWORK *work, u16 top, u16 num);

//---------------------------------------------------------
// Constants
const u16 SprBlockSize[12] = { // ^C̏
	1, 4, 16, 64,
	2, 4,  8, 32,
	2, 4,  8, 32,
};
const u16 SprCopySize[12] = { // sizeof(u16) * x
	8, 32, 128, 512,
	16, 32, 64, 256,
	16, 32, 64, 256,
};
const u16 SprHorizontalLength[12] = { // hbg
	 8, 16, 32, 64,
	16, 32, 32, 64,
	 8,  8, 16, 32,
};
const u16 SprVerticalLength[12] = { // chbg
	 8, 16, 32, 64,
	 8,  8, 16, 32,
	16, 32, 32, 64,
};
const SPR_SHAPE SprShapeAttribute[12] = {
	{ SP_SQUARE ,SP_SIZE_8  }, // OBJ_SIZE_8x8
	{ SP_SQUARE ,SP_SIZE_16 }, // OBJ_SIZE_16x16
	{ SP_SQUARE ,SP_SIZE_32 }, // OBJ_SIZE_32x32
	{ SP_SQUARE ,SP_SIZE_64 }, // OBJ_SIZE_64x64
	{ SP_WIDE   ,SP_SIZE_8  }, // OBJ_SIZE_16x8
	{ SP_WIDE   ,SP_SIZE_16 }, // OBJ_SIZE_32x8
	{ SP_WIDE   ,SP_SIZE_32 }, // OBJ_SIZE_32x16
	{ SP_WIDE   ,SP_SIZE_64 }, // OBJ_SIZE_64x32
	{ SP_TALL   ,SP_SIZE_8  }, // OBJ_SIZE_8x16
	{ SP_TALL   ,SP_SIZE_16 }, // OBJ_SIZE_8x32
	{ SP_TALL   ,SP_SIZE_32 }, // OBJ_SIZE_16x32
	{ SP_TALL   ,SP_SIZE_64 }, // OBJ_SIZE_32x64
};

//---------------------------------------------------------
// XvCgS
//---------------------------------------------------------
CODE_IN_IWRAM 
void 
SpriteInit(SPRWORK *work, SPR_PAT *SprPat)
{
	SprPattern = SprPat;
	SpriteRealInit(0,128); // XvCg
	SpriteWorkInit(work, 0, MAX_WORKSPR); // zXvCg
}

//---------------------------------------------------------
// XvCg
//---------------------------------------------------------
CODE_IN_IWRAM 
static 
void 
SpriteRealInit(u16 top, u16 num)
{
	s16 i = num;
	OAMEntry *sprites = (OAMEntry*)OAMmem; // OAM = (u32*)0x07000000
	sprites += top;

	while (i-- > 0) {
		sprites->attribute0 = 0xa0; // YW160ɂ
		sprites->attribute1 = 0xf0; // XW240ɂ
		sprites->attribute2 = 0;
		sprites->attribute3 = 0;
		sprites++;
	}
	return;
}

//---------------------------------------------------------
// zXvCg
//---------------------------------------------------------
CODE_IN_IWRAM 
static 
void 
SpriteWorkInit(SPRWORK *work, u16 top, u16 num)
{
	s16 i = num;
	u16 j;

	SprUsed = 0;
	SprHead.prev = NULL;
	SprHead.next = &SprTail;
	SprHead.disp = 0;
	SprHead.priority = SPRPRI_SYS_HEAD;

	SprTail.prev = &SprHead;
	SprTail.next = NULL;
	SprTail.disp = 0;
	SprTail.priority = SPRPRI_SYS_TAIL;

	LastSpr = &SprHead;

	work += top;
	while (i-- > 0) {
		for (j = 0; j < sizeof(SPRWORK); j++) {
			*(char *)(&work[0] + j) = 0;
		}
		SprStack[i] = &work[0];
		work->prev = NULL;
		work->next = NULL;
		work++;
	}
	return;
}

//---------------------------------------------------------
// zXvCgo^
//---------------------------------------------------------
CODE_IN_IWRAM
SPRWORK *
SpriteSet(u8 priority)
{
	SPRWORK *ret_work;
	SPRWORK *now_work;

	if (SprUsed == MAX_WORKSPR)
		return &tempSprWork; // XvCgI[o[

	ret_work = SprStack[SprUsed];

	// DxrĂ
	now_work = LastSpr;
	if (priority <= now_work->priority) {
		do {
			now_work = now_work->next;
		} while (priority <= now_work->priority);
		// }
		ret_work->next = now_work;
		ret_work->prev = now_work->prev;
		ret_work->prev->next = ret_work;
		ret_work->next->prev = ret_work;
	} else {
		while (priority > now_work->priority) {
			now_work = now_work->prev;
		}
		// }
		ret_work->prev = now_work;
		ret_work->next = now_work->next;
		ret_work->prev->next = ret_work;
		ret_work->next->prev = ret_work;
	}

	ret_work->priority = priority;

	SprStack[SprUsed] = NULL; // pop
	SprUsed++;
	return ret_work;
}

//---------------------------------------------------------
// zXvCgJ
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpriteKill(SPRWORK* work)
{
	u16 tile;
	if (work == &tempSprWork) return;

	work->next->prev = work->prev;
	work->prev->next = work->next;

	tile = work->attr2 & 0x03ff;
	PCG_ReleaseTile(tile);

	work->priority = 0;
	work->disp = 0;
	work->prev = NULL;
	work->next = NULL;
	work->attr0 = 0x00a0;
	work->attr1 = 0x00f0;
	work->attr2 = 0x0000;

	SprUsed--;
	SprStack[SprUsed] = work; // push

	return;
}

//---------------------------------------------------------
// DxύX
//---------------------------------------------------------
CODE_IN_IWRAM
void
SpritePriority(SPRWORK* work, u8 priority)
{
	SPRWORK *temp;

	if (work == &tempSprWork) return;

	if (priority < work->priority) {
		temp = work->next;
		work->next->prev = work->prev;
		work->prev->next = work->next;
		while (priority < temp->priority) {
			temp = temp->next;
		}
		work->prev = temp->prev;
		work->next = temp;
		work->prev->next = work;
		work->next->prev = work;
	} else
	if (priority > work->priority) {
		temp = work->prev;
		work->next->prev = work->prev;
		work->prev->next = work->next;
		while (priority > temp->priority) {
			temp = temp->prev;
		}
		work->prev = temp;
		work->next = temp->next;
		work->prev->next = work;
		work->next->prev = work;
	}
	work->priority = priority;
	return;
}

//---------------------------------------------------------
// zXvCgXvCgɔf
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpriteUpdate(void)
{
	s16 entryNum = MAX_SPRITES;
	SPRWORK32 *work = (SPRWORK32 *)SprHead.next;
	OAMEntry32 *obj32 = (OAMEntry32 *)OAMmem;
//	RotData *rot = (OAMEntry*)OAMmem;

	// NI[AXvCg̋󂫂0ɂȂ烋[vI
	while ((SPRWORK32 *)&SprTail != work && 0 != entryNum) {
		if (work->disp) {
			obj32->attribute01 = work->attr01;
			obj32->attribute2 = work->attr2;
			obj32++; //
			entryNum--;
		}
		work = work->next;
	} 

	// gp̎XvCg͔\ɂ
	while (entryNum > 0) {
		obj32->attribute01 = 0x00f000a0;
		obj32++;
		entryNum--;
	}

	return;
}


//==============================================================================

#ifndef USE_SPR_MACRO
//---------------------------------------------------------
// [hWƃrEWZbg
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpriteSetWorld(s32 x, s32 y)
{
	world_x = x;
	world_y = y;
	return;
}
CODE_IN_IWRAM
void 
SpriteSetView(s32 x, s32 y)
{
	view_x = x;
	view_y = y;
	return;
}

//---------------------------------------------------------
// XvCgLN^ꊇύX
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpritePattern(SPRWORK* work, u16 num)
{
	SPR_PAT *pat = &SprPattern[num];
	u16 a0, a1, tile, old;

	if (work == &tempSprWork) return;

	// `𓾂
	a0 = SprShapeAttribute[pat->shape].a0;
	a1 = SprShapeAttribute[pat->shape].a1;

	// p^[
	old = work->attr2 & 0x03ff;
	PCG_ReleaseTile(old);

	// ^Cԍ𓾂
	tile = PCG_Set(num);

	work->attr0 &= ~(SP_WIDE | SP_TALL);
	work->attr0 |= a0;
	work->attr1 &= ~(SP_SIZE_8 | SP_SIZE_16 | SP_SIZE_32 | SP_SIZE_64);
	work->attr1 |= a1;
	work->attr2 &= ~(MAX_TILES - 1);
	work->attr2 |= tile;
	return;
}

//---------------------------------------------------------
// XvCgړ
//---------------------------------------------------------
// W
CODE_IN_IWRAM
void 
SpriteMove(SPRWORK* work, s16 x, s16 y)
{
	x &= 0x01ff;
	y &= 0x00ff;
	work->attr1 = work->attr1 & 0xFC00;
	work->attr1 = work->attr1 | x;
	work->attr0 = work->attr0 & 0xFF00;
	work->attr0 = work->attr0 | y;
	return;
}

// [hW
CODE_IN_IWRAM
void 
SpriteMoveWorld(SPRWORK* work, s16 x, s16 y)
{
	u16 shape = GET_OBJ_SHAPE(work);
	s32 spx = x - view_x;
	s32 spy = y - view_y;
	if (spx > 240
	    || spy > 160
	    || (spx < - SprHorizontalLength[shape] )
	    || (spy < - SprVerticalLength[shape] )
	   )
	{
		spx = 240;
		spy = 160;
	} else { 
		spx &= 0x01ff;
		spy &= 0x00ff;
	}
	work->attr1 = work->attr1 & 0xFC00;
	work->attr1 = work->attr1 | spx;
	work->attr0 = work->attr0 & 0xFF00;
	work->attr0 = work->attr0 | spy;
	return;
}

//---------------------------------------------------------
//	XvCg̃TCYݒ
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpriteSize(SPRWORK* work, u16 size)
{
	work->attr1 &= 0x3FFF;
	work->attr1 |= ((size & 3) << 14);
	return;
}

//---------------------------------------------------------
// XvCgLN^ύX
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpriteChangeNumber(SPRWORK* work, u16 num)
{
//	num &= 0x03ff;
	work->attr2 &= 0xFC00;
	work->attr2 |= num;
	return;
}

//---------------------------------------------------------
// XvCgpbgύX
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpriteChangePallete(SPRWORK* work, u16 num)
{
	num &= 0x0f;
	num <<= 12;
	work->attr2 &= 0x0fff;
	work->attr2 |= num;
	return;
}

//---------------------------------------------------------
// XvCgvCIeBύX
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpriteChangePriority(SPRWORK* work, u16 num)
{
	num &= 0x03;
	num <<= 10;
	work->attr2 &= 0xf3ff;
	work->attr2 |= num;
	return;
}

//---------------------------------------------------------
// XvCgtbvύX
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpriteChangeFlip(SPRWORK* work, u16 num)
{
//	num &= 0x03;
//	num <<= 10;
	num &= (SP_HORIZONTAL_FLIP | SP_VERTICAL_FLIP);
	work->attr1 &= ~(SP_HORIZONTAL_FLIP | SP_VERTICAL_FLIP);
	work->attr1 |= num;
	return;
}

//---------------------------------------------------------
// XvCg[hύX
//---------------------------------------------------------
CODE_IN_IWRAM
void 
SpriteMode(SPRWORK* work, u16 num)
{
	num &= (SP_MODE_TRANSPERANT | SP_MODE_WINDOWED);
	work->attr0 &= ~(SP_MODE_TRANSPERANT | SP_MODE_WINDOWED);
	work->attr0 |= num;
	return;
}

#endif

//==============================================================================

