#ifndef _PDRV_INST_H
#define _PDRV_INST_H
#include <gba.h>

#ifdef __cplusplus
extern "C" {
#endif

#include <gba.h>

#define MAX_SPLIT		8

#define TYPE_ONESHOT	0x00
#define TYPE_LOOP		0x80


// Sound Data Structure
typedef struct {
	u32 size;		// TvOf[^̑oCg
	u32 loop;		// [v̊Jn_
	u16 freqNum;	// g (0-3)
	u16 type;		// 
	s8 data[0];
} ATTR_PACKED SND;

// Instrument Split Structure
typedef struct {
	u8 split;				// Split
	u8 rootkey;				// Root Key
	u8 ar;					// Attack
	u8 dr;					// Decay
	u8 sr;					// Sustain
	u8 rr;					// Release
	u8 sl;					// Sustain Level
	u8 reserve;				// 
	SND *snd;				// 
} ATTR_PACKED SPLIT;

// Instrument Bank
typedef struct {
	SPLIT bank[MAX_SPLIT];
} ATTR_PACKED INSTBANK;

#ifdef __cplusplus
}
#endif

#endif // _PDRV_INST_H
